namespace boost {

namespace serializer {

template <typename ClassType,
          typename RecvType,
          BOOST_PP_REPEAT(BOOST_SERIALIZER_NUM_ARGS, BOOST_SERIALIZE_TRAITS_TEMPLATE_ARG_DECLARE, ())
          typename Dummy>
struct serialize_traits <ClassType, RecvType, BOOST_SERIALIZER_NUM_ARGS,
	BOOST_PP_REPEAT(BOOST_SERIALIZER_NUM_ARGS, BOOST_SERIALIZE_TRAITS_TEMPLATE_ARG_PASS, ())
	Dummy> {
	typedef ClassType class_type;
	typedef RecvType receive_type;
	static const unsigned int static_size = BOOST_SERIALIZER_NUM_ARGS;
	BOOST_PP_REPEAT(BOOST_SERIALIZER_NUM_ARGS, BOOST_SERIALIZE_TRAITS_SPEC_TYPEDEFS, ())

	// FIXME Make some of this private and friend anything that needs access
	typedef boost::tuple <
		BOOST_PP_REPEAT(BOOST_SERIALIZER_NUM_ARGS, BOOST_SERIALIZE_TRAITS_SPEC_GET_TYPES, ())
		bool>
		get_fun_type;
	typedef boost::tuple <
		BOOST_PP_REPEAT(BOOST_SERIALIZER_NUM_ARGS, BOOST_SERIALIZE_TRAITS_SPEC_EXPORT_TYPES, ())
		bool>
		export_fun_type;

	get_fun_type    get_fun;
	export_fun_type export_fun;

	inline serialize_traits(
		BOOST_PP_REPEAT(BOOST_SERIALIZER_NUM_ARGS, BOOST_SERIALIZE_TRAITS_SPEC_CTOR_PARAMS, ())
		bool dummy=true) :
		get_fun(
			BOOST_PP_REPEAT(BOOST_SERIALIZER_NUM_ARGS, BOOST_SERIALIZE_TRAITS_SPEC_CTOR_GET_INITLIST, ())
			true),
		export_fun(
			BOOST_PP_REPEAT(BOOST_SERIALIZER_NUM_ARGS, BOOST_SERIALIZE_TRAITS_SPEC_CTOR_EXPORT_INITLIST, ())
			true)
	{
	}
};

}

}
